<?php
namespace Controllers;
// Контроллер Настроек
class Settings extends Controller {

	public function __construct() {
		parent::__construct();
		$this->model=new \Models\Settings($this->f3);
		if($this->db) {
			$this->model=new \Models\Settings($this->f3, $this->db);
		}
		else {
			$this->model=new \Models\Settings($this->f3);
		}
	}

	// Настройки для подключения к API
	function api() {
		$data=$this->controller->get_api_config();
		$this->f3->set('data', $data);
		$this->f3->set('page_data', $this->model->page_data('api'));
	}

	// Сохраняем настройки для подключения к API
	function post_api() {
		$post=$this->f3->get('POST');
		$res=$this->model->post_api($post); // пытаемся сохранить настройки
		$res['txt']=$this->messages->message($res['txt'])['txt']; // получаем текст ответа
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Страница синхронизации
	function synchronization() {
		$data=$this->db->exec("SELECT auto_sinch FROM synchronization LIMIT 1");
		$this->f3->set('auto_sinch', $data[0]['auto_sinch']);
		$this->f3->set('page_data', $this->model->page_data('synchronization'));
	}

	// Включаем или выключаем автосинхронизацию
	function post_synchronization() {
		$auto_sinch=$this->f3->get('POST.auto_sinch');
		$res=$this->model->post_synchronization($this->db, $auto_sinch);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Продолжение печати, выход из аварийного состояни
	function continue_print() {
		$fr=new \Models\Fr($this->db, $this->f3);
		$res=$fr->continue_print();
		$this->f3->set('page_data', $this->messages->message($res['txt']));
	}

	// Обнуление чека
	function reset_ticket() {
		$fr=new \Models\Fr($this->db, $this->f3);
		$res=$fr->reset_ticket();
		$this->f3->set('page_data', $this->messages->message($res['txt']));
	}

	// Настройка фискального регистратора
	function kkm() {
		$fr=new \Models\Fr($this->db, $this->f3);
		$data=$fr->get_fr();
		$this->f3->set('data', $data);
		$drivers=$fr->get_drivers();
		$this->f3->set('drivers', $drivers);
		$p=new \Models\Paymentmethods($this->db, $this->f3);
		$pays=$p->select_method();
		$this->f3->set('pays', $pays);
		$this->f3->set('page_data', $this->model->page_data('kkm'));
	}

	// Сохраняем настройки ФР
	function post_kkm() {
		$post=$this->f3->get('POST');
		$fr=new \Models\Fr($this->db, $this->f3);
		$res=$fr->save_fr($post);
		$res['txt']=$this->messages->message($res['txt'])['txt']; // получаем текст ответа
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Сброс всех настроек и удаление базы данных
	function reset() {
		$res=$this->model->reset();
		$res['txt']=$this->messages->message($res['txt'])['txt']; // получаем текст ответа
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Ошибки при синхронизации
	function logs() {
		$limit=$this->f3->get('lines_of_page');
		$page=$this->f3->get('GET.page');
		if(!$page)$page=1;
		$logs=$this->logs->logs_list(($page-1)*$limit, $limit);
		$this->f3->set('logs', $logs['logs']);
		$this->f3->set('pagination', $this->pagination($logs['count'], $page));
		$this->f3->set('page_data', $this->model->page_data('logs'));
	}

	function post_logs() {
		$id=$this->f3->get('POST.id');
		$res=$this->logs->read($id);
		$res['txt']=$this->messages->message($res['txt'])['txt']; // получаем текст ответа
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	function read_all_logs() {
		$res=$this->logs->read_all();
		$res['txt']=$this->messages->message($res['txt'])['txt']; // получаем текст ответа
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Настройка дисплея покупателя
	function customer_display() {
		$cd=new \Models\Cd($this->db, $this->f3);
		$data=$cd->get_cd();
		$drivers=$cd->get_drivers();
		$this->f3->set('drivers', $drivers);
		$this->f3->set('data', $data);
		$this->f3->set('page_data', $this->model->page_data('cd'));
	}

	// Сохраняем настройки дисплея покупателя
	function post_customer_display() {
		$post=$this->f3->get('POST');
		$cd=new \Models\Cd($this->db, $this->f3);
		$res=$cd->save_cd($post);
		$res['txt']=$this->messages->message($res['txt'])['txt']; // получаем текст ответа
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Страница сервисных команд
	function service() {
		$this->f3->set('page_data', $this->model->page_data('service'));
	}

	// Произвольная команда
	function post_service() {
		$strs=$this->f3->get('POST.commands');
		$fr=new \Models\Fr($this->db, $this->f3);
		$fr_sets=$fr->get_fr();
		if($fr_sets['active']) {
			$fr->send_ajax($strs, null, true);
			exit();
		}
		$res=array(
			'success'=>false,
			'txt'=>$this->messages->message('kkm_is_not_activity')['txt']
		);
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Запрос полного статуса ККМ
	function status_kkm() {
		$fr=new \Models\Fr($this->db, $this->f3);
		$fr_sets=$fr->get_fr();
		if($fr_sets['active']) {
			$fr->status_kkm();
			exit();
		}
		$res=array(
			'success'=>false,
			'txt'=>$this->messages->message('kkm_is_not_activity')['txt']
		);
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Страница основных настроек программы
	function base() {
		$this->f3->set('page_data', $this->model->page_data('base'));
	}

	// Сохраняем основные настройки программы
	function post_base() {
		$post=$this->f3->get('POST');
		if(!isset($post['auto_fullscreen']))$post['auto_fullscreen']=0;
		if(!isset($post['virtual_keyboard']))$post['virtual_keyboard']=0;
		$res=$this->model->save_base($post);
		$res['txt']=$this->messages->message($res['txt'])['txt']; // получаем текст ответа
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Управление залами
	function rooms() {
		$id=$this->f3->get('GET.id');
		$r=new \Models\Rooms($this->db, $this->f3);
		$rooms=$r->select_rooms();
		$room=$rooms[0];
		$tables=array();
		if($id) {
			// Находим выбранный зал
			foreach ($rooms as $r) {
				if($r['id']==$id) {
					$room=$r;
					break;
				}
			}
		}
		if(!empty($room)) {
			// Если зал выбран, то находим столы
			$t=new \Models\Tables($this->db, $this->f3);
			$tables=$t->tables_form_room($room['id']);
		}
		$this->f3->set('room', $room);
		$this->f3->set('tables', $tables);
		$this->f3->set('rooms', $rooms);
		$this->f3->set('page_data', $this->model->page_data('rooms'));
	}

	// Настройка драйвера
	function drivers() {
		$path=$this->f3->get('GET.path');
		$file=$path.'/server.config';
		if(file_exists($file)) {
			$txt=file_get_contents($file);
			$config=parse_ini_file($file);
			$this->f3->set('config', $config);
			$this->f3->set('txt', $txt);
			$this->f3->set('page_data', $this->model->page_data('drivers'));
		}
		else {
			$this->f3->set('page_data', $this->messages->message('not_found'));
		}
	}

	// Сохраняем настройки драйвера
	function post_drivers() {
		$post=$this->f3->get('POST');
		$res=$this->model->save_driver($post);
		$res['txt']=$this->messages->message($res['txt'])['txt']; // получаем текст ответа
		echo json_encode($res); // сообщаем что вышло
		exit();
	}

	// Запуск драйвера
	function start_driver() {
		$driver=$this->f3->get('GET.path');
		$res=$this->model->start_driver($driver);
		$this->f3->set('page_data', $this->messages->message($res['txt']));
	}
}
